/*
 * ȣХϥե
 *	ܾϥɥ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_base.c,v 1.1 2000/08/15 00:34:46 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

enum {
	WAAB_ANALYZE_NEW,
	WAAB_ANALYZE_ADD,
};

static GtkWidget		*Waab_menu;		// ˥塼С
static GtkWidget		*Waab_logfile;	// ե̾
static GtkWidget		*Waab_spcdate;	// դλ
static GtkAdjustment	*Waab_syear;	// ǯ
static GtkAdjustment	*Waab_smonth;	// Ϸ
static GtkAdjustment	*Waab_sday;		// 
static GtkAdjustment	*Waab_eyear;	// λǯ
static GtkAdjustment	*Waab_emonth;	// λ
static GtkAdjustment	*Waab_eday;		// λ
static GtkWidget		*Waab_spin[6];	// 
static GtkWidget		*Waab_spcpage;	// ϥڡλ
static GtkWidget		*Waab_page;		// ϥڡ
static GtkWidget		*Waab_total;	// 
static GtkWidget		*Waab_host;		// ˡۥȿ

static void			waaw_cb_window_destroy(void);
static void			waab_cb_spcdate_clicked(GtkWidget *);
static void			waab_cb_spcpage_clicked(GtkWidget *);
static void			waaw_cb_analyze(GtkWidget *, gpointer, guint);
static GtkWidget	*waaw_create_main_menu(GtkWidget *);

/*===============
 *   ̾ : waa_create_base_window()
 *     ǽ : ɥ
 *    : ܾϥɥ
 */
GtkWidget			*waa_create_base_window(void)
{
	GtkWidget		*base_window;		// ܾϥɥ
	gchar			*title;				// ȥʸ
	GtkWidget		*base_vbox;			//
	GtkWidget		*menu_handle;		// ˥塼ܥå
	GtkWidget		*log_vbox;			//
	GtkWidget		*log_label;			// ե
	GtkWidget		*date_vbox;			//
	GtkWidget		*ymd_hbox;			//
	gboolean		spc_value;			// ػꤹ٥ե饰
	GtkWidget		*ymd_label;			// ǯ٥
	time_t			ymd_time;			// ɽ
	struct tm		*ymd_stime;			// ɽ
	gfloat			ymd_value;			// ǯ
	GtkWidget		*oth_hbox;			//
	GtkWidget		*page_vbox;			//
	GtkWidget		*page_hbox;			//
	GtkWidget		*page_label;		// ڡ
	gchar			*page_value;		//
	GtkWidget		*info_vbox;			//
	GtkWidget		*info_hbox;			//
	GtkWidget		*info_label;		// Ͼ

	// ᥤ󥦥ɥ
	title = g_strconcat(_(WAA_TITLE), NULL);
	base_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(base_window), title);
	gtk_widget_set_usize(GTK_WIDGET(base_window), 550, 230);
	gtk_window_set_default_size(GTK_WINDOW(base_window),
						(gint)waa_get_param(WAA_PRM_KEY_BASEWIDTH, 0),
						(gint)waa_get_param(WAA_PRM_KEY_BASEHEIGHT, 0));
	gtk_signal_connect(GTK_OBJECT(base_window), "destroy",
						GTK_SIGNAL_FUNC(waaw_cb_window_destroy),
						NULL);
	gtk_widget_realize(base_window);
	g_free(title);

	// ˥塼С
	base_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(base_vbox), 1);
	gtk_container_add(GTK_CONTAINER(base_window), base_vbox);

	menu_handle = gtk_handle_box_new();
	gtk_box_pack_start(GTK_BOX(base_vbox), menu_handle, FALSE, TRUE, 0);

	Waab_menu = waaw_create_main_menu(base_window);
	gtk_container_add(GTK_CONTAINER(menu_handle), Waab_menu);
	waa_set_save_sensitive(FALSE);

	// ե
	log_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(log_vbox), 10);
	gtk_box_pack_start(GTK_BOX(base_vbox), log_vbox, FALSE, TRUE, 0);

	log_label = gtk_label_new(_(WAA_STRB_LOGFILE));
	gtk_misc_set_alignment(GTK_MISC(log_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(log_vbox), log_label, FALSE, TRUE, 0);

	Waab_logfile = gtk_combo_new();
	gtk_box_pack_start(GTK_BOX(log_vbox), Waab_logfile, FALSE, TRUE, 0);
	waa_create_logfile();

	// դλ
	date_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(date_vbox), 10);
	gtk_box_pack_start(GTK_BOX(base_vbox), date_vbox, FALSE, TRUE, 0);

	Waab_spcdate = gtk_check_button_new_with_label(_(WAA_STRB_SPCDATE));
	gtk_box_pack_start(GTK_BOX(date_vbox), Waab_spcdate, FALSE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(Waab_spcdate), "clicked",
						GTK_SIGNAL_FUNC(waab_cb_spcdate_clicked), NULL);

	// 
	ymd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(date_vbox), ymd_hbox, TRUE, TRUE, 5);

	ymd_time = (time_t)waa_get_param(WAA_PRM_KEY_STARTDATE, 0);
	ymd_stime = localtime(&ymd_time);
	ymd_value = (gfloat)ymd_stime->tm_year + 1900;
	Waab_syear = (GtkAdjustment *)gtk_adjustment_new(ymd_value,
									0.0, 2100.0, 1.0, 100.0, 0.0);
	Waab_spin[0] = gtk_spin_button_new(Waab_syear, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(Waab_spin[0]), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(Waab_spin[0]),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(Waab_spin[0], 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), Waab_spin[0], FALSE, TRUE, 5);
	ymd_label = gtk_label_new(_(WAA_STRB_YEAR));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mon + 1;
	Waab_smonth = (GtkAdjustment *)gtk_adjustment_new(ymd_value,
									1.0, 12.0, 1.0, 5.0, 0.0);
	Waab_spin[1] = gtk_spin_button_new(Waab_smonth, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(Waab_spin[1]), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(Waab_spin[1]),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(Waab_spin[1], 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), Waab_spin[1], FALSE, TRUE, 5);
	ymd_label = gtk_label_new(_(WAA_STRB_MONTH));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mday;
	Waab_sday = (GtkAdjustment *)gtk_adjustment_new(ymd_value,
									1.0, 31.0, 1.0, 5.0, 0.0);
	Waab_spin[2] = gtk_spin_button_new(Waab_sday, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(Waab_spin[2]), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(Waab_spin[2]),
 									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(Waab_spin[2], 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), Waab_spin[2], FALSE, TRUE, 5);
	ymd_label = gtk_label_new(_(WAA_STRB_DAY));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_label = gtk_label_new(_(WAA_STRB_FROM));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	// λ
	ymd_time = (time_t)waa_get_param(WAA_PRM_KEY_ENDDATE, 0);
	ymd_stime = localtime(&ymd_time);
	ymd_value = (gfloat)ymd_stime->tm_year + 1900;
	Waab_eyear = (GtkAdjustment *)gtk_adjustment_new(ymd_value,
									0.0, 2100.0, 1.0, 100.0, 0.0);
	Waab_spin[3] = gtk_spin_button_new(Waab_eyear, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(Waab_spin[3]), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(Waab_spin[3]),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(Waab_spin[3], 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), Waab_spin[3], FALSE, TRUE, 5);
	ymd_label = gtk_label_new(_(WAA_STRB_YEAR));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mon + 1;
	Waab_emonth = (GtkAdjustment *)gtk_adjustment_new(ymd_value,
									1.0, 12.0, 1.0, 5.0, 0.0);
	Waab_spin[4] = gtk_spin_button_new(Waab_emonth, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(Waab_spin[4]), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(Waab_spin[4]),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(Waab_spin[4], 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), Waab_spin[4], FALSE, TRUE, 5);
	ymd_label = gtk_label_new(_(WAA_STRB_MONTH));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mday;
	Waab_eday = (GtkAdjustment *)gtk_adjustment_new(ymd_value,
									1.0, 31.0, 1.0, 5.0, 0.0);
	Waab_spin[5] = gtk_spin_button_new(Waab_eday, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(Waab_spin[5]), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(Waab_spin[5]),
 									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(Waab_spin[5], 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), Waab_spin[5], FALSE, TRUE, 5);
	ymd_label = gtk_label_new(_(WAA_STRB_DAY));
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	// դɽ
	spc_value = (gboolean)!waa_get_param(WAA_PRM_KEY_SPCDATE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waab_spcdate),
								spc_value);

	// ϥڡλ
	oth_hbox = gtk_hbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(oth_hbox), 0);
	gtk_box_pack_start(GTK_BOX(base_vbox), oth_hbox, FALSE, TRUE, 0);

	page_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(oth_hbox), page_vbox, TRUE, TRUE, 10);

	Waab_spcpage = gtk_check_button_new_with_label(_(WAA_STRB_SPCPAGE));
	gtk_box_pack_start(GTK_BOX(page_vbox), Waab_spcpage, FALSE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(Waab_spcpage), "clicked",
						GTK_SIGNAL_FUNC(waab_cb_spcpage_clicked), NULL);

	// ϥڡ
	page_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(page_vbox), page_hbox, TRUE, TRUE, 5);
	page_label = gtk_label_new(_(WAA_STRB_PAGE));
	gtk_misc_set_alignment(GTK_MISC(page_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(page_hbox), page_label, FALSE, TRUE, 2);

	Waab_page = gtk_entry_new_with_max_length(10);
	gtk_box_pack_start(GTK_BOX(page_hbox), Waab_page, FALSE, TRUE, 2);
	page_value = waa_get_param(WAA_PRM_KEY_PAGE, 0);
	gtk_entry_set_text(GTK_ENTRY(Waab_page), page_value);

	// ϥڡɽ
	spc_value = (gboolean)!waa_get_param(WAA_PRM_KEY_SPCPAGE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waab_spcpage),
								spc_value);

	// 
	info_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(oth_hbox), info_vbox, TRUE, TRUE, 5);
	info_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(info_vbox), info_hbox, TRUE, TRUE, 5);

	Waab_total = gtk_entry_new_with_max_length(10);
	gtk_entry_set_editable(GTK_ENTRY(Waab_total), FALSE);
	gtk_box_pack_end(GTK_BOX(info_hbox), Waab_total, FALSE, TRUE, 2);

	info_label = gtk_label_new(_(WAA_STRB_TOTAL));
	gtk_misc_set_alignment(GTK_MISC(info_label), 0, 0.5);
	gtk_box_pack_end(GTK_BOX(info_hbox), info_label, FALSE, TRUE, 2);

	// ˡۥ
	info_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(info_vbox), info_hbox, TRUE, TRUE, 5);

	Waab_host = gtk_entry_new();
	gtk_entry_set_editable(GTK_ENTRY(Waab_host), FALSE);
	gtk_box_pack_end(GTK_BOX(info_hbox), Waab_host, FALSE, TRUE, 2);

	info_label = gtk_label_new(_(WAA_STRB_HOST));
	gtk_misc_set_alignment(GTK_MISC(info_label), 0, 0.5);
	gtk_box_pack_end(GTK_BOX(info_hbox), info_label, FALSE, TRUE, 2);

	return base_window;
}

/*===============
 *   ̾ : waa_set_save_sensitive()
 *     ǽ : ¸ܥ̵ͭ
 *    : ʤ
 */
void				waa_set_save_sensitive(
gboolean			status				// (I) ܥ
)
{
	GtkWidget		*save_button;		// ¸ܥ
	gchar			*save_str;			// ¸ܥʸ

	save_str = g_strconcat(_(WAA_MN_FILE WAA_MNF_SAVE), NULL);
	save_button = gtk_item_factory_get_item(
					gtk_item_factory_from_widget(Waab_menu), save_str);
	g_free(save_str);

	if (GTK_IS_WIDGET(save_button)) {
		gtk_widget_set_sensitive(save_button, status);
	}
}

/*===============
 *   ̾ : waa_create_logfile()
 *     ǽ : եܥåι
 *    : ʤ
 */
void				waa_create_logfile(void)
{
static GtkWidget	**log_label;		// ե̾
	gint			loop_cnt;			// 롼ץ
	gchar			*log_name;			// ե̾
	GtkContainer	*log_cont;			// ꥹ

	if (!log_label) {
		log_label = (GtkWidget **)
					g_malloc0(WAA_MAX_LOGFILE * sizeof(GtkWidget *));
	}
	log_cont = GTK_CONTAINER(GTK_COMBO(Waab_logfile)->list);
	for (loop_cnt = 0; loop_cnt < WAA_MAX_LOGFILE; loop_cnt++) {
		if (log_label[loop_cnt]) {
			gtk_container_remove(log_cont, log_label[loop_cnt]);
		}
	}

	for (loop_cnt = 0; loop_cnt < WAA_MAX_LOGFILE; loop_cnt++) {
		log_name = waa_get_param(WAA_PRM_KEY_LOGFILE, loop_cnt);
		if (*log_name != '\0') {
			log_label[loop_cnt] =
				gtk_list_item_new_with_label(log_name);
			gtk_container_add(log_cont, log_label[loop_cnt]);
			gtk_widget_show(log_label[loop_cnt]);
		}
	}
}

/*===============
 *   ̾ : waaw_cb_window_destroy()
 *     ǽ : λ
 *    : ʤ
 */
static void			waaw_cb_window_destroy(void)
{
	waa_write_inifile();
	gtk_main_quit();
}

/*===============
 *   ̾ : waab_cb_spcdate_clicked()
 *     ǽ : դꤹåܥå
 *    : ʤ
 */
static void			waab_cb_spcdate_clicked(
GtkWidget			*button				// (I) ܥ
)
{
	gboolean		spc_value;			// ܥ
	gint			loop_cnt;			// 롼ץ

	spc_value = GTK_TOGGLE_BUTTON(Waab_spcdate)->active ^ 1;
	for (loop_cnt = 0; loop_cnt < 6; loop_cnt++) {
		gtk_widget_set_sensitive(Waab_spin[loop_cnt], spc_value);
	}
}

/*===============
 *   ̾ : waab_cb_spcpage_clicked()
 *     ǽ : ϥڡꤹåܥå
 *    : ʤ
 */
static void			waab_cb_spcpage_clicked(
GtkWidget			*button				// (I) ܥ
)
{
	gboolean		spc_value;			// ܥ

	spc_value = GTK_TOGGLE_BUTTON(Waab_spcpage)->active ^ 1;
	gtk_widget_set_sensitive(Waab_page, spc_value);
}

/*===============
 *   ̾ : waaw_cb_analyze()
 *     ǽ : ϥܥ󲡲
 *    : ʤ
 */
static void			waaw_cb_analyze(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ᥤ󥦥ɥ
guint				analyze_type		// (I) ɲ
)
{
	gboolean		err_flag = TRUE;	// 顼̵ͭ (TRUE= ʤ)
	gchar			*log_file;			// ե̾
	gboolean		spc_value;			// ػꤹ٥ե饰
	gfloat			year_value;			// ǯ
	gfloat			month_value;		// 
	gfloat			day_value;			// 
	struct tm		spc_date;			// 
	gchar			*page_str;			// ϥڡ
	gchar			access_num[20];		// 
	gint			max_line;			// ϤԿ
	gchar			*err_msg;			// 顼å

	log_file =
		gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(Waab_logfile)->entry));
	if (access(log_file, R_OK) >= 0) {
		gtk_widget_grab_focus(GTK_COMBO(Waab_logfile)->entry);
		waa_put_param(WAA_PRM_KEY_LOGFILE, log_file);
		waa_create_logfile();

		// 
		spc_value = GTK_TOGGLE_BUTTON(Waab_spcdate)->active;
		waa_put_param(WAA_PRM_KEY_SPCDATE, (void *)!spc_value);
		if (spc_value == FALSE) {
			year_value = GTK_ADJUSTMENT(Waab_syear)->value;
			month_value = GTK_ADJUSTMENT(Waab_smonth)->value;
			day_value = GTK_ADJUSTMENT(Waab_sday)->value;
			memset(&spc_date, 0, sizeof(struct tm));
			spc_date.tm_year = year_value - 1900;
			spc_date.tm_mon = month_value - 1;
			spc_date.tm_mday = day_value;
			waa_put_param(WAA_PRM_KEY_STARTDATE,
						(void *)mktime(&spc_date));
			year_value = GTK_ADJUSTMENT(Waab_eyear)->value;
			month_value = GTK_ADJUSTMENT(Waab_emonth)->value;
			day_value = GTK_ADJUSTMENT(Waab_eday)->value;
			memset(&spc_date, 0, sizeof(struct tm));
			spc_date.tm_year = year_value - 1900;
			spc_date.tm_mon = month_value - 1;
			spc_date.tm_mday = day_value;
			waa_put_param(WAA_PRM_KEY_ENDDATE,
						(void *)mktime(&spc_date));
		}

		// ϥڡ
		spc_value = GTK_TOGGLE_BUTTON(Waab_spcpage)->active;
		waa_put_param(WAA_PRM_KEY_SPCPAGE, (void *)!spc_value);
		if (spc_value == FALSE) {
			page_str = gtk_entry_get_text(GTK_ENTRY(Waab_page));
			if (page_str[0] != '\0') {
				waa_put_param(WAA_PRM_KEY_PAGE, page_str);
			}
			else {
				wmc_create_emsg_dialog(main_window,
					_(WAA_STR_ERROR), _(WAA_STR_ERR_PAGE));
				err_flag = FALSE;
			}
		}

		// եͭԿå
		if (err_flag == TRUE) {
			max_line = waa_get_analyze_line();
			if (max_line > 0) {
				waa_create_pbar_window(_(WAA_STR_ANALYZE),
										(gfloat)max_line);
			}
			else {
				wmc_create_emsg_dialog(main_window,
					_(WAA_STR_ERROR), _(WAA_STR_ERR_NONLOG));
				err_flag = FALSE;
			}
		}

		// 
		if (err_flag == TRUE) {
			if (analyze_type == WAAB_ANALYZE_NEW) {
				waa_access_analyze(TRUE);
			}
			else if (analyze_type == WAAB_ANALYZE_ADD) {
				waa_access_analyze(FALSE);
			}
			waa_pbar_value_change((gfloat)max_line + 1);

			if (waa_get_total_access() < 1) {
				wmc_create_emsg_dialog(main_window,
					_(WAA_STR_ERROR), _(WAA_STR_ERR_NONDATA));
				err_flag = FALSE;
			}
		}
	}
	else {
		err_msg = g_malloc0((strlen(log_file) +
					strlen(_(WAA_STR_ERR_NOTFILE)) + 2) * sizeof(char));
		sprintf(err_msg, "%s\n%s", _(WAA_STR_ERR_NOTFILE), log_file);
		wmc_create_emsg_dialog(main_window, _(WAA_STR_ERROR), err_msg);
		g_free(err_msg);
		err_flag = FALSE;
	}

	// Ͼ󹹿
	waa_set_save_sensitive(err_flag);
	if (err_flag == FALSE) {
		if (analyze_type == WAAB_ANALYZE_NEW) {
			waa_init_analyze();
		}
	}
	sprintf(access_num, "%d", waa_get_total_access());
	gtk_entry_set_text(GTK_ENTRY(Waab_total), access_num);
	sprintf(access_num, "%d", waa_get_item_num(WAA_WINNO_HOST));
	gtk_entry_set_text(GTK_ENTRY(Waab_host), access_num);
	waa_draw_month();
	waa_draw_week();
	waa_draw_dweek();
	waa_draw_date();
	waa_draw_time();
	waa_draw_os();
	waa_draw_brws();
	waa_draw_host();
	waa_draw_ref();
	waa_draw_page();
}

/*===============
 *   ̾ : waaw_create_main_menu()
 *     ǽ : ˥塼
 *    : ˥塼
 */
static GtkWidget	*waaw_create_main_menu(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkItemFactoryEntry menu_items[] = {// ˥塼
		{NULL, NULL, NULL, 0, "<Branch>"},
		{NULL, "<control>O",
			waa_cb_mfile_fsel_clicked, WAA_FSEL_OPEN, NULL},
		{NULL, "<control>S",
			waa_cb_mfile_fsel_clicked, WAA_FSEL_SAVE, NULL},
		{NULL, NULL, NULL, 0, "<Separator>"},
		{NULL, "<control>Q", waaw_cb_window_destroy, 0, NULL},

		{NULL, NULL, NULL, 0, "<Branch>"},
		{NULL, "<control>L", waaw_cb_analyze, WAAB_ANALYZE_NEW, NULL },
		{NULL, NULL, waaw_cb_analyze, WAAB_ANALYZE_ADD, NULL },

		{NULL, NULL, NULL, 0, "<Branch>"},
		{NULL, NULL, NULL, 0, "<Tearoff>"},
		{NULL, "<control>M", waa_cb_view_month, 0, NULL },
		{NULL, "<control>E", waa_cb_view_week, 0, NULL },
		{NULL, "<control>K", waa_cb_view_dweek, 0, NULL },
		{NULL, "<control>D", waa_cb_view_date, 0, NULL },
		{NULL, "<control>N", waa_cb_view_time, 0, NULL },
		{NULL, "<control>A", waa_cb_view_os, 0, NULL },
		{NULL, "<control>W", waa_cb_view_brws, 0, NULL },
		{NULL, "<control>H", waa_cb_view_host, 0, NULL },
		{NULL, "<control>R", waa_cb_view_ref, 0, NULL },
		{NULL, "<control>G", waa_cb_view_page, 0, NULL },
#if 0
		{NULL, NULL, NULL, 0, "<Separator>"},
		{NULL, "<control>O", waa_cb_view_option, 0, NULL },
#endif

		{NULL, NULL, NULL, 0, "<LastBranch>"},
		{NULL, NULL,
			waa_cb_mhelp_about_clicked, GPOINTER_TO_UINT(parent), NULL},
	};
	gint			nmenu_items;		// ˥塼ܿ
	gint			loop_cnt;			// 롼ץ
	gint			item_no;			// ˥塼ֹ
	GtkItemFactory	*item_factory;		//
	GtkAccelGroup	*accel_group;		//

	item_no = 0;
	menu_items[item_no++].path = g_strconcat(_(WAA_MN_FILE_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_FILE WAA_MNF_OPEN_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_FILE WAA_MNF_SAVE_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_FILE "/sep1"), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_FILE WAA_MNF_QUIT_), NULL);

	menu_items[item_no++].path = g_strconcat(_(WAA_MN_EDIT_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_EDIT WAA_MNE_NEWALZ_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_EDIT WAA_MNE_ADDALZ_), NULL);

	menu_items[item_no++].path = g_strconcat(_(WAA_MN_VIEW_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW "/tearoff"), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_MONTH_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_WEEK_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_DWEEK_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_DATE_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_TIME_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_OS_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_BRWS_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_HOST_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_REF_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_PAGE_), NULL);
#if 0
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW "/sep1"), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_VIEW WAA_MNV_OPTION_), NULL);
#endif

	menu_items[item_no++].path = g_strconcat(_(WAA_MN_HELP_), NULL);
	menu_items[item_no++].path =
		g_strconcat(_(WAA_MN_HELP WAA_MNH_ABOUT_), NULL);

	nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
	accel_group = gtk_accel_group_new();
	item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
									"<main>", accel_group);
	gtk_item_factory_create_items_ac(item_factory,
					nmenu_items, menu_items, parent, 2);

	gtk_accel_group_attach(accel_group, GTK_OBJECT(parent));

	for (loop_cnt = 0; loop_cnt < 1/*nmenu_items*/; loop_cnt++) {
		g_free(menu_items[loop_cnt].path);
	}
	return gtk_item_factory_get_widget(item_factory, "<main>");
}
