/*
 * ȣХϥե
 *	̲ϥɥ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_date.c,v 1.1 2000/08/15 00:34:46 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static GtkWidget	*Waad_win;				// ̲ϥɥ
static GtkWidget	*Waad_darea;			// 襨ꥢ
static GdkPixmap	*Waad_pixmap = NULL;	// 襨ꥢ
static GdkGC		*Waad_gc_color[] = {	// ɽ
						NULL, NULL, NULL
					};
static GdkFont		*Waad_font = NULL;		// ե
static GdkFont		*Waad_kfont = NULL;		// ܸե

static GtkWidget	*waad_create_date_window(GtkWidget *);
static void			waad_cb_destroy_window(void);
static gint			waad_cb_darea_expose(GtkWidget *, GdkEventExpose *);
static gint			waad_cb_darea_config(GtkWidget *,
										GdkEventConfigure *);
static void			waad_create_gc(GtkWidget *);
static void			waad_draw_date(gint, gint, gint, gint);

/*===============
 *   ̾ : waa_cb_view_date()
 *     ǽ : ̲ϥɥκ
 *    : ʤ
 */
void				waa_cb_view_date(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	gint			vis_win;			// ɽΥɥ

	if (Waad_win != NULL) {
		gtk_widget_destroy(Waad_win);
	}
	Waad_win = waad_create_date_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(Waad_win);

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win |= WAA_WINNO_DATE;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waa_draw_date()
 *     ǽ : ̥(ƽ)
 *    : ʤ
 */
void				waa_draw_date(void)
{
	gint			width;				// 襨ꥢ
	gint			height;				// 襨ꥢ⤵

	if (Waad_pixmap != NULL) {
		width = (gint)waa_get_param(WAA_PRM_KEY_DATEWIDTH, 0);
		height = (gint)waa_get_param(WAA_PRM_KEY_DATEHEIGHT, 0);

		if ((width > 0) && (height > 0)) {
			gdk_draw_rectangle(Waad_pixmap,
								Waad_gc_color[1],
								TRUE,
								0, 0,
								width, height);

			waad_draw_date(0, 0, width, height);

			gdk_draw_pixmap(Waad_darea->window,
				Waad_darea->style->fg_gc[GTK_WIDGET_STATE(Waad_darea)],
				Waad_pixmap,
				0, 0,
				0, 0,
				width, height);
		}
	}
}

/*===============
 *   ̾ : waa_modify_date_color_gc()
 *     ǽ : ѹ
 *    : ʤ
 */
void				waa_modify_date_color_gc(
gint				color_no,			// ֹ
gchar				*prm_key			// ѥ᡼
)
{
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	temp_color = waa_get_param(prm_key, 0);
	gdk_color_alloc(cmap, temp_color);
	gdk_gc_set_foreground(Waad_gc_color[color_no], temp_color);
}

/*===============
 *   ̾ : waad_create_date_window()
 *     ǽ : ̲ϥɥ
 *    : ̲ϥɥ
 */
static GtkWidget	*waad_create_date_window(
GtkWidget			*parent				// (I) ƥå
)
{
	GtkWidget		*date_window;		// ɥ
	GtkWidget		*draw_vbox;			// 襨ꥢܥå
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_DATE), NULL);
	date_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(date_window), title); 
	gtk_window_set_default_size(GTK_WINDOW(date_window),
					(gint)waa_get_param(WAA_PRM_KEY_DATEWIDTH, 0),
					(gint)waa_get_param(WAA_PRM_KEY_DATEHEIGHT, 0));
	gtk_window_set_position(GTK_WINDOW(date_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(date_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(date_window), "destroy",
						GTK_SIGNAL_FUNC(waad_cb_destroy_window), NULL);
	g_free(title);

	// 襨ꥢ
	draw_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(date_window), draw_vbox);
	Waad_darea = gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA(Waad_darea), 100, 100);
	gtk_box_pack_start(GTK_BOX(draw_vbox), Waad_darea, TRUE, TRUE, 0);

	gtk_signal_connect(GTK_OBJECT(Waad_darea), "expose_event",
						(GtkSignalFunc)waad_cb_darea_expose, NULL);
	gtk_signal_connect(GTK_OBJECT(Waad_darea), "configure_event",
						(GtkSignalFunc)waad_cb_darea_config, NULL);

	return date_window;
}

/*===============
 *   ̾ : waad_cb_destroy_window()
 *     ǽ : ɥõХå
 *    : ʤ
 */
static void			waad_cb_destroy_window(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			gc_size;			// 顼
	gint			vis_win;			// ɽΥɥ

	gdk_font_unref(Waad_kfont);
	Waad_kfont = NULL;
	gdk_font_unref(Waad_font);
	Waad_font = NULL;

	gc_size = sizeof(Waad_gc_color) / sizeof(Waad_gc_color[0]);
	for (loop_cnt = 0; loop_cnt < gc_size; loop_cnt++) {
		gdk_gc_destroy(Waad_gc_color[loop_cnt]);
		Waad_gc_color[loop_cnt] = NULL;
	}
	gdk_pixmap_unref(Waad_pixmap);
	Waad_pixmap = NULL;
	gtk_widget_destroy(Waad_win);
	Waad_win = NULL;

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win &= ~WAA_WINNO_DATE;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waad_cb_darea_expose()
 *     ǽ : 襨ꥢ襳Хå
 *    : FALSE= ｪλ
 */
static gint			waad_cb_darea_expose(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventExpose		*event				// (I) ٥Ⱦ
)
{
	gdk_draw_pixmap(widget->window,
					widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
					Waad_pixmap,
					event->area.x, event->area.y,
					event->area.x, event->area.y,
					event->area.width, event->area.height);

	return FALSE;
}

/*===============
 *   ̾ : waad_cb_darea_config()
 *     ǽ : 襨ꥢꥢ饤Хå
 *    : TRUE= ｪλ
 */
static gint			waad_cb_darea_config(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventConfigure	*event				// (I) ٥Ⱦ
)
{
	gint			win_size;			// 襨ꥢ⤵

	if (Waad_pixmap) {
		gdk_pixmap_unref(Waad_pixmap);
	}
	waad_create_gc(widget);

	win_size = widget->allocation.width;
	waa_put_param(WAA_PRM_KEY_DATEWIDTH, (void *)win_size);
	win_size = widget->allocation.height;
	waa_put_param(WAA_PRM_KEY_DATEHEIGHT, (void *)win_size);

	Waad_pixmap = gdk_pixmap_new(widget->window,
								widget->allocation.width,
								widget->allocation.height,
								-1);
	gdk_draw_rectangle(Waad_pixmap,
						Waad_gc_color[1],
						TRUE,
						0, 0,
						widget->allocation.width,
						widget->allocation.height);
	waa_draw_date();

	return TRUE;
}

/*===============
 *   ̾ : waad_create_gc()
 *     ǽ : եåƥȤκ
 *    : ʤ
 */
static void			waad_create_gc(
GtkWidget			*widget				// (I) 襨ꥢ
)
{
	gchar			*prm_key[] = {		// ѥ᡼
						WAA_PRM_KEY_GRAPHFORE,
						WAA_PRM_KEY_GRAPHBACK,
						WAA_PRM_KEY_GRAPHDATE,
					};
	gint			loop_cnt;			// 롼ץ
	gchar			*font_name;			// ե̾
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	for (loop_cnt = 0; loop_cnt < 3; loop_cnt++) {
		if (!Waad_gc_color[loop_cnt]) {
			Waad_gc_color[loop_cnt] = gdk_gc_new(widget->window);
			temp_color = waa_get_param(prm_key[loop_cnt], 0);
			gdk_color_alloc(cmap, temp_color);
			gdk_gc_set_foreground(Waad_gc_color[loop_cnt], temp_color);
		}
		gdk_gc_set_line_attributes(Waad_gc_color[loop_cnt],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	}

	if (!Waad_font) {
		font_name = waa_get_param(WAA_PRM_KEY_FONTNAME, 0);
		Waad_font = gdk_fontset_load(font_name);
	}
	if (!Waad_kfont) {
		font_name = waa_get_param(WAA_PRM_KEY_KANJIFONT, 0);
		Waad_kfont = gdk_fontset_load(font_name);
	}
}

/*===============
 *   ̾ : waad_draw_date()
 *     ǽ : ̥
 *    : ʤ
 */
static void			waad_draw_date(
gint				pos_x,				// (I) 賫ϰ
gint				pos_y,				// (I) 賫ϰ
gint				width,				// (I) 
gint				height				// (I) ⤵
)
{
	gint			mrg_width;			// ޡ
	gint			mrg_height;			// ޡ⤵
	gint			text_x;				// ɽ(ƥ)
	gint			text_y;				// ɽ(ƥ)
	gint			text_width;			// ɽƥĹ
	gint			from_x = 0;			// ɽ
	gint			from_y = 0;			// ɽ
	gint			to_x;				// ɽ
	gint			to_y;				// ɽ
	gint			loop_cnt;			// 롼ץ
	gdouble			scale_x;			// غɸ
	gdouble			scale_y;			// ٺɸ
	gchar			draw_str[10];		// ʸ
	gint			access_num;			// 
	gint			max_access;			// 祢
	gint			date_num;			// Τäտ
	gint			enable_date[31];	// ͭ
	gint			date_access[31];	// Υ

	mrg_width = 15;
	mrg_height = 15;
	max_access = 0;
	date_num = 0;
	memset(enable_date, 0, sizeof(enable_date));
	for (loop_cnt = 0; loop_cnt < 31; loop_cnt++) {
		access_num = waa_get_access_num(WAA_WINNO_DATE, loop_cnt);
		if (max_access < access_num) {
			max_access = access_num;
		}
		if (access_num > 0) {
			enable_date[date_num] = loop_cnt;
			date_access[date_num] = access_num;
			date_num++;
		}
	}

	scale_x = (gdouble)(width - (mrg_width * 2)) / date_num;
	scale_y = (gdouble)(height - (mrg_height * 2)) / max_access;
	mrg_width += pos_x;
	mrg_height += pos_y;
	gdk_gc_set_line_attributes(Waad_gc_color[2],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	from_y = height - mrg_height;
	for (loop_cnt = 0; loop_cnt < date_num; loop_cnt++) {
		from_x = mrg_width + scale_x * loop_cnt;
		to_x = mrg_width + scale_x * (loop_cnt + 1);
		to_y = (mrg_height + pos_y) +
				(max_access - date_access[loop_cnt]) * scale_y;
		gdk_draw_rectangle(Waad_pixmap,
				Waad_gc_color[2],
				FALSE,
				from_x, to_y,
				(to_x - from_x), (from_y - to_y));

		// ɽ
		sprintf(draw_str, "%d%s",
			enable_date[loop_cnt] + 1, _(WAA_STRG_DATE));
		text_width = wmc_gdk_text_width(Waad_font, Waad_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width +
				(scale_x * (loop_cnt * 2 + 1) - text_width) / 2;
		text_y = height - mrg_height - gdk_text_height(Waad_font,
							draw_str, strlen(draw_str)) * 2;
		wmc_gdk_draw_text(Waad_pixmap,
					Waad_font,
					Waad_kfont,
					Waad_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));

		// ɽ
		sprintf(draw_str, "%d", date_access[loop_cnt]);
		text_width = wmc_gdk_text_width(Waad_font, Waad_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width +
				(scale_x * (loop_cnt * 2 + 1) - text_width) / 2;
		text_y = height - mrg_height - gdk_text_height(Waad_font,
							draw_str, strlen(draw_str));
		wmc_gdk_draw_text(Waad_pixmap,
					Waad_font,
					Waad_kfont,
					Waad_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));
	}
}
