/*
 * ȣХϥե
 *	ѥ᡼ͤμ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_param.c,v 1.1 2000/08/15 00:34:46 tonton Exp $
 */

#include <sys/param.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

#define		WAAP_INIFILE	"acalz.ini"

/* ǥե */
#define		WAAP_PRM_DEF_BASEWIDTH		550
#define		WAAP_PRM_DEF_BASEHEIGHT		230
#define		WAAP_PRM_DEF_MONTHWIDTH		350
#define		WAAP_PRM_DEF_MONTHHEIGHT	250
#define		WAAP_PRM_DEF_WEEKWIDTH		350
#define		WAAP_PRM_DEF_WEEKHEIGHT		250
#define		WAAP_PRM_DEF_DWEEKWIDTH		350
#define		WAAP_PRM_DEF_DWEEKHEIGHT	250
#define		WAAP_PRM_DEF_DATEWIDTH		350
#define		WAAP_PRM_DEF_DATEHEIGHT		250
#define		WAAP_PRM_DEF_TIMEWIDTH		350
#define		WAAP_PRM_DEF_TIMEHEIGHT		250
#define		WAAP_PRM_DEF_OSWIDTH		350
#define		WAAP_PRM_DEF_OSHEIGHT		250
#define		WAAP_PRM_DEF_BRWSWIDTH		350
#define		WAAP_PRM_DEF_BRWSHEIGHT		250
#define		WAAP_PRM_DEF_HOSTWIDTH		350
#define		WAAP_PRM_DEF_HOSTHEIGHT		250
#define		WAAP_PRM_DEF_REFWIDTH		350
#define		WAAP_PRM_DEF_REFHEIGHT		250
#define		WAAP_PRM_DEF_PAGEWIDTH		350
#define		WAAP_PRM_DEF_PAGEHEIGHT		250
#define		WAAP_PRM_DEF_CHECKLINE		500

#define		WAAP_PRM_DEF_VISWINDOW		0
#define		WAAP_PRM_DEF_LOGFILE		"access.log"
#define		WAAP_PRM_DEF_PAGE			"index"
#define		WAAP_PRM_DEF_MAXDISP		25

#define		WAAP_PRM_DEF_GRAPHFORE		{0, 0x0000, 0x0000, 0x0000}
#define		WAAP_PRM_DEF_GRAPHBACK		{0, 0xffff, 0xffff, 0xffff}
#define		WAAP_PRM_DEF_GRAPHMONTH		{0, 0xffff, 0x0000, 0x0000}
#define		WAAP_PRM_DEF_GRAPHWEEK		{0, 0xffff, 0x8000, 0x8000}
#define		WAAP_PRM_DEF_GRAPHDWEEK		{0, 0xffff, 0x8000, 0x4000}
#define		WAAP_PRM_DEF_GRAPHDATE		{0, 0xeb00, 0xe100, 0x7300}
#define		WAAP_PRM_DEF_GRAPHTIME		{0, 0x0000, 0xffff, 0x4000}
#define		WAAP_PRM_DEF_GRAPHOS		{0, 0x0000, 0xffff, 0xffff}
#define		WAAP_PRM_DEF_GRAPHBRWS		{0, 0x0000, 0x8000, 0xffff}
#define		WAAP_PRM_DEF_GRAPHHOST		{0, 0x0000, 0x2000, 0x8000}
#define		WAAP_PRM_DEF_GRAPHREF		{0, 0x8000, 0x0000, 0x8000}
#define		WAAP_PRM_DEF_GRAPHPAGE		{0, 0xffff, 0x8000, 0xffff}

#define		WAAP_PRM_DEF_FONTNAME		"6x12"
#define		WAAP_PRM_DEF_KANJIFONT		"k12"

enum {
	WAAP_TYPE_BOOL = 1,
	WAAP_TYPE_INT,
	WAAP_TYPE_CHAR,
	WAAP_TYPE_TIME,
	WAAP_TYPE_COLOR,
	WAAP_TYPE_LOG
};

typedef struct {
	gint			prm_type;			// ѥ᡼
	gchar			*prm_name;			// ѥ᡼̾
	union {
		gboolean	b_value;			// ֡뷿
		gint		i_value;			// 
		gchar		*s_value;			// ʸ
		time_t		t_value;			// ַ
		GdkColor	c_value;			// 
		gchar		**l_value;			// 
	}				prm_value;			// ѥ᡼
} WAAP_PVALUE;
static WAAP_PVALUE	Waap_pvalue[] = {	// ѥ᡼
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BASEWIDTH, WAAP_PRM_DEF_BASEWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BASEHEIGHT, WAAP_PRM_DEF_BASEHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_MONTHWIDTH, WAAP_PRM_DEF_MONTHWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_MONTHHEIGHT, WAAP_PRM_DEF_MONTHHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_WEEKWIDTH, WAAP_PRM_DEF_WEEKWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_WEEKHEIGHT, WAAP_PRM_DEF_WEEKHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DWEEKWIDTH, WAAP_PRM_DEF_DWEEKWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DWEEKHEIGHT, WAAP_PRM_DEF_DWEEKHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DATEWIDTH, WAAP_PRM_DEF_DATEWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DATEHEIGHT, WAAP_PRM_DEF_DATEHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_TIMEWIDTH, WAAP_PRM_DEF_TIMEWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_TIMEHEIGHT, WAAP_PRM_DEF_TIMEHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_OSWIDTH, WAAP_PRM_DEF_OSWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_OSHEIGHT, WAAP_PRM_DEF_OSHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BRWSWIDTH, WAAP_PRM_DEF_BRWSWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BRWSHEIGHT, WAAP_PRM_DEF_BRWSHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_HOSTWIDTH, WAAP_PRM_DEF_HOSTWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_HOSTHEIGHT, WAAP_PRM_DEF_HOSTHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_REFWIDTH, WAAP_PRM_DEF_REFWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_REFHEIGHT, WAAP_PRM_DEF_REFHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_PAGEWIDTH, WAAP_PRM_DEF_PAGEWIDTH },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_PAGEHEIGHT, WAAP_PRM_DEF_PAGEHEIGHT },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_CHECKLINE, WAAP_PRM_DEF_CHECKLINE },

	{ WAAP_TYPE_INT, WAA_PRM_KEY_VISWINDOW, WAAP_PRM_DEF_VISWINDOW },
	{ WAAP_TYPE_LOG, WAA_PRM_KEY_LOGFILE, 0 },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SPCDATE, TRUE },
	{ WAAP_TYPE_TIME, WAA_PRM_KEY_STARTDATE, 0 },
	{ WAAP_TYPE_TIME, WAA_PRM_KEY_ENDDATE, 0 },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SPCPAGE, TRUE },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_PAGE, 0 },

	{ WAAP_TYPE_INT, WAA_PRM_KEY_MAXDISP, WAAP_PRM_DEF_MAXDISP },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREIP, FALSE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SPCCLASS, TRUE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_CODECHANGE, TRUE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SMALLIZE, FALSE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREINDEX, TRUE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREQUESTION, TRUE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNORESHARP, TRUE },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREPORTNO, TRUE },

	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHFORE, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHBACK, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHMONTH, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHWEEK, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHDWEEK, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHDATE, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHTIME, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHOS, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHBRWS, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHHOST, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHREF, 0 },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHPAGE, 0 },

	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FONTNAME, 0 },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_KANJIFONT, 0 },

	{ 0, NULL, 0 }
};

static void			waa_set_default_value(void);

/*===============
 *   ̾ : waa_get_param()
 *     ǽ : ѥ᡼ͤμ
 *    : ѥ᡼
 */
void				*waa_get_param(
gchar				*param_key,			// (I) ѥ᡼ɣ
gint				option_id			// (I) ղþ
)
{
	void			*param_value = NULL;// ѥ᡼
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	value_ptr = Waap_pvalue;
	while ((value_ptr->prm_type != 0) && (param_value == NULL)) {
		if (!strcmp(value_ptr->prm_name, param_key)) {
			if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
				param_value = (void *)value_ptr->prm_value.b_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_INT) {
				param_value = (void *)value_ptr->prm_value.i_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
				param_value = (void *)value_ptr->prm_value.s_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
				param_value = (void *)value_ptr->prm_value.t_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				param_value = (void *)&value_ptr->prm_value.c_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
				param_value =
					(void *)value_ptr->prm_value.l_value[option_id];
			}
		}
		value_ptr++;
	}

	return param_value;
}

/*===============
 *   ̾ : waa_put_param()
 *     ǽ : ѥ᡼ͤΥå
 *    : ʤ
 */
void				waa_put_param(
gchar				*param_key,			// (I) ѥ᡼ɣ
void				*param_value		// (I) ѥ᡼
)
{
	gint			find_flag = FALSE;	// ե饰
	gint			loop_cnt;			// 롼ץ
	gint			tmp_num;			// ¸ե
	char			**new_log;			// ե̾
	char			**work_log;			// ѥե̾
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	value_ptr = Waap_pvalue;
	while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
		if (!strcmp(value_ptr->prm_name, param_key)) {
			if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
				value_ptr->prm_value.b_value = (gboolean)param_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_INT) {
				value_ptr->prm_value.i_value = (gint)param_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
				value_ptr->prm_value.s_value =
					g_realloc(value_ptr->prm_value.s_value,
					strlen(param_value) + 1);
				strcpy(value_ptr->prm_value.s_value, param_value);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
				value_ptr->prm_value.t_value = (time_t)param_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				memcpy(&value_ptr->prm_value.c_value,
					param_value, sizeof(GdkColor));
			}
			else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
				work_log = value_ptr->prm_value.l_value;
				new_log = (char **)g_malloc0(WAA_MAX_LOGFILE *
												sizeof(char *));
				tmp_num = 5;
				for (loop_cnt = (WAA_MAX_LOGFILE - 1);
					loop_cnt >= 0; loop_cnt--) {
					if (strcmp(param_value, work_log[loop_cnt])) {
						tmp_num--;
						new_log[tmp_num] =
							g_malloc0((strlen(work_log[loop_cnt]) + 1) *
							sizeof(char));
						strcpy(new_log[tmp_num], work_log[loop_cnt]);
					}
				}
				if (tmp_num == 0) {
					free(new_log[4]);
					memmove(&new_log[1], new_log,
						sizeof(char *) * (WAA_MAX_LOGFILE - 1));
				}
				new_log[0] = g_malloc0((strlen(param_value) + 1) *
												sizeof(char));
				strcpy(new_log[0], param_value);
				for (loop_cnt = 0;
					loop_cnt < WAA_MAX_LOGFILE; loop_cnt++) {
					free(value_ptr->prm_value.l_value[loop_cnt]);
				}
				free(value_ptr->prm_value.l_value);
				value_ptr->prm_value.l_value = new_log;
			}
			find_flag = TRUE;
		}
		value_ptr++;
	}
}

/*===============
 *   ̾ : waa_read_inifile()
 *     ǽ : եɤ߹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gboolean			waa_read_inifile(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			find_flag;			// ե饰
	gint			find_logfile;		// ե饰
	gint			loop_cnt;			// 롼ץ
	gchar			fname[MAXPATHLEN];	// ե̾
	gchar			key_str[100];		// 
	gchar			key_value[100];		// 
	FILE			*infp;				// եݥ
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	find_logfile = FALSE;
	value_ptr = Waap_pvalue;
	find_flag = FALSE;
	while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
		if (!strcmp(value_ptr->prm_name, WAA_PRM_KEY_LOGFILE)) {
			value_ptr->prm_value.l_value =
				(char **)g_malloc0(WAA_MAX_LOGFILE * sizeof(char *));
			for (loop_cnt = 0; loop_cnt < WAA_MAX_LOGFILE; loop_cnt++) {
				value_ptr->prm_value.l_value[loop_cnt] =
									g_malloc0(sizeof(char));
			}
			find_flag = TRUE;
		}
		value_ptr++;
	}
	waa_set_default_value();


	strcpy(fname, WAAP_INIFILE);
	infp = fopen(fname, "r");
	if (infp) {
		while (wmc_get_key_value(key_str, key_value, infp) == TRUE) {
			value_ptr = Waap_pvalue;
			find_flag = FALSE;
			while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
				if (!strcmp(value_ptr->prm_name, key_str)) {
					if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
						value_ptr->prm_value.b_value = atoi(key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_INT) {
						value_ptr->prm_value.i_value = atoi(key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
						waa_put_param(value_ptr->prm_name, key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
						value_ptr->prm_value.t_value = atoi(key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
						wmc_get_color(&value_ptr->prm_value.c_value,
															key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
						waa_put_param(value_ptr->prm_name, key_value);
						find_logfile = TRUE;
					}
					find_flag = TRUE;
				}
				value_ptr++;
			}
		}
		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	if (find_logfile == FALSE) {
		waa_put_param(WAA_PRM_KEY_LOGFILE, WAAP_PRM_DEF_LOGFILE);
	}
	return ret_code;
}

/*===============
 *   ̾ : waa_write_inifile()
 *     ǽ : եν񤭹
 *    : TRUE= ｪλ, FALSE= ѡߥåʤʤ
 */
gboolean			waa_write_inifile(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			loop_cnt;			// 롼ץ
	gint			prm_size;			// ѥ᡼
	gchar			fname[MAXPATHLEN];	// ե̾
	FILE			*outfp;				// եݥ
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	strcpy(fname, WAAP_INIFILE);
	outfp = fopen(fname, "w");
	if (outfp) {
		prm_size = sizeof(Waap_pvalue) / sizeof(Waap_pvalue[0]);
		value_ptr = Waap_pvalue;
		while (value_ptr->prm_type != 0) {
			if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
				fprintf(outfp, "%s = %d\n",
					value_ptr->prm_name,
					value_ptr->prm_value.b_value);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_INT) {
				fprintf(outfp, "%s = %d\n",
					value_ptr->prm_name,
					value_ptr->prm_value.i_value);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
				fprintf(outfp, "%s = %s\n",
					value_ptr->prm_name,
					value_ptr->prm_value.s_value);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
				fprintf(outfp, "%s = %ld\n",
					value_ptr->prm_name,
					value_ptr->prm_value.t_value);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				fprintf(outfp, "%s = %ld, %d, %d, %d\n",
					value_ptr->prm_name,
					value_ptr->prm_value.c_value.pixel,
					value_ptr->prm_value.c_value.red,
					value_ptr->prm_value.c_value.green,
					value_ptr->prm_value.c_value.blue);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
				for (loop_cnt = (WAA_MAX_LOGFILE - 1);
					loop_cnt >= 0; loop_cnt--) {
					if (value_ptr->prm_value.l_value[loop_cnt][0] !=
																'\0') {
						fprintf(outfp, "%s = %s\n",
							value_ptr->prm_name,
							value_ptr->prm_value.l_value[loop_cnt]);
					}
				}
			}
			value_ptr++;
		}

		fclose(outfp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : waa_set_default_value()
 *     ǽ : ǥեȥѥ᡼
 *    : ʤ
 */
static void			waa_set_default_value(void)
{
	GdkColor		def_color[] = {		// ɽ
						WAAP_PRM_DEF_GRAPHFORE,
						WAAP_PRM_DEF_GRAPHBACK,
						WAAP_PRM_DEF_GRAPHMONTH,
						WAAP_PRM_DEF_GRAPHWEEK,
						WAAP_PRM_DEF_GRAPHDWEEK,
						WAAP_PRM_DEF_GRAPHDATE,
						WAAP_PRM_DEF_GRAPHTIME,
						WAAP_PRM_DEF_GRAPHOS,
						WAAP_PRM_DEF_GRAPHBRWS,
						WAAP_PRM_DEF_GRAPHHOST,
						WAAP_PRM_DEF_GRAPHREF,
						WAAP_PRM_DEF_GRAPHPAGE
					};
	time_t			ini_date;			// 
	struct tm		ini_sdate;			//

	ini_date = time(NULL);
	memcpy(&ini_sdate, localtime(&ini_date), sizeof(struct tm));
	ini_sdate.tm_hour = 0;
	ini_sdate.tm_min = 0;
	ini_sdate.tm_sec = 0;
	ini_date = mktime(&ini_sdate);
	waa_put_param(WAA_PRM_KEY_ENDDATE, (void *)ini_date);
	ini_sdate.tm_mday = 1;
	ini_date = mktime(&ini_sdate);
	waa_put_param(WAA_PRM_KEY_STARTDATE, (void *)ini_date);

	waa_put_param(WAA_PRM_KEY_PAGE, WAAP_PRM_DEF_PAGE);

	waa_put_param(WAA_PRM_KEY_GRAPHFORE, def_color);
	waa_put_param(WAA_PRM_KEY_GRAPHBACK, &def_color[1]);
	waa_put_param(WAA_PRM_KEY_GRAPHMONTH, &def_color[2]);
	waa_put_param(WAA_PRM_KEY_GRAPHWEEK, &def_color[3]);
	waa_put_param(WAA_PRM_KEY_GRAPHDWEEK, &def_color[4]);
	waa_put_param(WAA_PRM_KEY_GRAPHDATE, &def_color[5]);
	waa_put_param(WAA_PRM_KEY_GRAPHTIME, &def_color[6]);
	waa_put_param(WAA_PRM_KEY_GRAPHOS, &def_color[7]);
	waa_put_param(WAA_PRM_KEY_GRAPHBRWS, &def_color[8]);
	waa_put_param(WAA_PRM_KEY_GRAPHHOST, &def_color[9]);
	waa_put_param(WAA_PRM_KEY_GRAPHREF, &def_color[10]);
	waa_put_param(WAA_PRM_KEY_GRAPHPAGE, &def_color[11]);

	waa_put_param(WAA_PRM_KEY_FONTNAME, WAAP_PRM_DEF_FONTNAME);
	waa_put_param(WAA_PRM_KEY_KANJIFONT, WAAP_PRM_DEF_KANJIFONT);
}
