/*
 * ȣХϥե
 *	̲ϥɥ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_time.c,v 1.1 2000/08/15 00:34:46 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static GtkWidget	*Waat_win;				// ̲ϥɥ
static GtkWidget	*Waat_darea;			// 襨ꥢ
static GdkPixmap	*Waat_pixmap = NULL;	// 襨ꥢ
static GdkGC		*Waat_gc_color[] = {	// ɽ
						NULL, NULL, NULL
					};
static GdkFont		*Waat_font = NULL;		// ե
static GdkFont		*Waat_kfont = NULL;		// ܸե

static GtkWidget	*waat_create_time_window(GtkWidget *);
static void			waat_cb_destroy_window(void);
static gint			waat_cb_darea_expose(GtkWidget *, GdkEventExpose *);
static gint			waat_cb_darea_config(GtkWidget *,
										GdkEventConfigure *);
static void			waat_create_gc(GtkWidget *);
static void			waat_draw_time(gint, gint, gint, gint);

/*===============
 *   ̾ : waa_cb_view_time()
 *     ǽ : ̲ϥɥκ
 *    : ʤ
 */
void				waa_cb_view_time(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	gint			vis_win;			// ɽΥɥ

	if (Waat_win != NULL) {
		gtk_widget_destroy(Waat_win);
	}
	Waat_win = waat_create_time_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(Waat_win);

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win |= WAA_WINNO_TIME;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waa_draw_time()
 *     ǽ : ̥(ƽ)
 *    : ʤ
 */
void				waa_draw_time(void)
{
	gint			width;				// 襨ꥢ
	gint			height;				// 襨ꥢ⤵

	if (Waat_pixmap != NULL) {
		width = (gint)waa_get_param(WAA_PRM_KEY_TIMEWIDTH, 0);
		height = (gint)waa_get_param(WAA_PRM_KEY_TIMEHEIGHT, 0);

		if ((width > 0) && (height > 0)) {
			gdk_draw_rectangle(Waat_pixmap,
								Waat_gc_color[1],
								TRUE,
								0, 0,
								width, height);

			waat_draw_time(0, 0, width, height);

			gdk_draw_pixmap(Waat_darea->window,
				Waat_darea->style->fg_gc[GTK_WIDGET_STATE(Waat_darea)],
				Waat_pixmap,
				0, 0,
				0, 0,
				width, height);
		}
	}
}

/*===============
 *   ̾ : waa_modify_time_color_gc()
 *     ǽ : ѹ
 *    : ʤ
 */
void				waa_modify_time_color_gc(
gint				color_no,			// ֹ
gchar				*prm_key			// ѥ᡼
)
{
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	temp_color = waa_get_param(prm_key, 0);
	gdk_color_alloc(cmap, temp_color);
	gdk_gc_set_foreground(Waat_gc_color[color_no], temp_color);
}

/*===============
 *   ̾ : waat_create_time_window()
 *     ǽ : ̲ϥɥ
 *    : ̲ϥɥ
 */
static GtkWidget	*waat_create_time_window(
GtkWidget			*parent				// (I) ƥå
)
{
	GtkWidget		*time_window;		// ɥ
	GtkWidget		*draw_vbox;			// 襨ꥢܥå
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_TIME), NULL);
	time_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(time_window), title); 
	gtk_window_set_default_size(GTK_WINDOW(time_window),
					(gint)waa_get_param(WAA_PRM_KEY_TIMEWIDTH, 0),
					(gint)waa_get_param(WAA_PRM_KEY_TIMEHEIGHT, 0));
	gtk_window_set_position(GTK_WINDOW(time_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(time_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(time_window), "destroy",
						GTK_SIGNAL_FUNC(waat_cb_destroy_window), NULL);
	g_free(title);

	// 襨ꥢ
	draw_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(time_window), draw_vbox);
	Waat_darea = gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA(Waat_darea), 100, 100);
	gtk_box_pack_start(GTK_BOX(draw_vbox), Waat_darea, TRUE, TRUE, 0);

	gtk_signal_connect(GTK_OBJECT(Waat_darea), "expose_event",
						(GtkSignalFunc)waat_cb_darea_expose, NULL);
	gtk_signal_connect(GTK_OBJECT(Waat_darea), "configure_event",
						(GtkSignalFunc)waat_cb_darea_config, NULL);

	return time_window;
}

/*===============
 *   ̾ : waat_cb_destroy_window()
 *     ǽ : ɥõХå
 *    : ʤ
 */
static void			waat_cb_destroy_window(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			gc_size;			// 顼
	gint			vis_win;			// ɽΥɥ

	gdk_font_unref(Waat_kfont);
	Waat_kfont = NULL;
	gdk_font_unref(Waat_font);
	Waat_font = NULL;

	gc_size = sizeof(Waat_gc_color) / sizeof(Waat_gc_color[0]);
	for (loop_cnt = 0; loop_cnt < gc_size; loop_cnt++) {
		gdk_gc_destroy(Waat_gc_color[loop_cnt]);
		Waat_gc_color[loop_cnt] = NULL;
	}
	gdk_pixmap_unref(Waat_pixmap);
	Waat_pixmap = NULL;
	gtk_widget_destroy(Waat_win);
	Waat_win = NULL;

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win &= ~WAA_WINNO_TIME;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waat_cb_darea_expose()
 *     ǽ : 襨ꥢ襳Хå
 *    : FALSE= ｪλ
 */
static gint			waat_cb_darea_expose(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventExpose		*event				// (I) ٥Ⱦ
)
{
	gdk_draw_pixmap(widget->window,
					widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
					Waat_pixmap,
					event->area.x, event->area.y,
					event->area.x, event->area.y,
					event->area.width, event->area.height);

	return FALSE;
}

/*===============
 *   ̾ : waat_cb_darea_config()
 *     ǽ : 襨ꥢꥢ饤Хå
 *    : TRUE= ｪλ
 */
static gint			waat_cb_darea_config(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventConfigure	*event				// (I) ٥Ⱦ
)
{
	gint			win_size;			// 襨ꥢ⤵

	if (Waat_pixmap) {
		gdk_pixmap_unref(Waat_pixmap);
	}
	waat_create_gc(widget);

	win_size = widget->allocation.width;
	waa_put_param(WAA_PRM_KEY_TIMEWIDTH, (void *)win_size);
	win_size = widget->allocation.height;
	waa_put_param(WAA_PRM_KEY_TIMEHEIGHT, (void *)win_size);

	Waat_pixmap = gdk_pixmap_new(widget->window,
								widget->allocation.width,
								widget->allocation.height,
								-1);
	gdk_draw_rectangle(Waat_pixmap,
						Waat_gc_color[1],
						TRUE,
						0, 0,
						widget->allocation.width,
						widget->allocation.height);
	waa_draw_time();

	return TRUE;
}

/*===============
 *   ̾ : waat_create_gc()
 *     ǽ : եåƥȤκ
 *    : ʤ
 */
static void			waat_create_gc(
GtkWidget			*widget				// (I) 襨ꥢ
)
{
	gchar			*prm_key[] = {		// ѥ᡼
						WAA_PRM_KEY_GRAPHFORE,
						WAA_PRM_KEY_GRAPHBACK,
						WAA_PRM_KEY_GRAPHTIME,
					};
	gint			loop_cnt;			// 롼ץ
	gchar			*font_name;			// ե̾
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	for (loop_cnt = 0; loop_cnt < 3; loop_cnt++) {
		if (!Waat_gc_color[loop_cnt]) {
			Waat_gc_color[loop_cnt] = gdk_gc_new(widget->window);
			temp_color = waa_get_param(prm_key[loop_cnt], 0);
			gdk_color_alloc(cmap, temp_color);
			gdk_gc_set_foreground(Waat_gc_color[loop_cnt], temp_color);
		}
		gdk_gc_set_line_attributes(Waat_gc_color[loop_cnt],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	}

	if (!Waat_font) {
		font_name = waa_get_param(WAA_PRM_KEY_FONTNAME, 0);
		Waat_font = gdk_fontset_load(font_name);
	}
	if (!Waat_kfont) {
		font_name = waa_get_param(WAA_PRM_KEY_KANJIFONT, 0);
		Waat_kfont = gdk_fontset_load(font_name);
	}
}

/*===============
 *   ̾ : waat_draw_time()
 *     ǽ : ̥
 *    : ʤ
 */
static void			waat_draw_time(
gint				pos_x,				// (I) 賫ϰ
gint				pos_y,				// (I) 賫ϰ
gint				width,				// (I) 
gint				height				// (I) ⤵
)
{
	gint			mrg_width;			// ޡ
	gint			mrg_height;			// ޡ⤵
	gint			text_x;				// ɽ(ƥ)
	gint			text_y;				// ɽ(ƥ)
	gint			text_width;			// ɽƥĹ
	gint			from_x = 0;			// ɽ
	gint			from_y = 0;			// ɽ
	gint			to_x;				// ɽ
	gint			to_y;				// ɽ
	gint			loop_cnt;			// 롼ץ
	gdouble			scale_x;			// غɸ
	gdouble			scale_y;			// ٺɸ
	gchar			draw_str[10];		// ʸ
	gint			access_num;			// 
	gint			max_access;			// 祢
	gint			time_num;			// Τäֿ
	gint			enable_time[25];	// ͭʻ
	gint			time_access[25];	// Υ

	mrg_width = 15;
	mrg_height = 15;
	max_access = 0;
	time_num = 0;
	memset(enable_time, 0, sizeof(enable_time));
	for (loop_cnt = 0; loop_cnt < 25; loop_cnt++) {
		access_num = waa_get_access_num(WAA_WINNO_TIME, loop_cnt);
		if (max_access < access_num) {
			max_access = access_num;
		}
		if (access_num > 0) {
			enable_time[time_num] = loop_cnt;
			time_access[time_num] = access_num;
			time_num++;
		}
	}

	scale_x = (gdouble)(width - (mrg_width * 2)) / time_num;
	scale_y = (gdouble)(height - (mrg_height * 2)) / max_access;
	mrg_width += pos_x;
	mrg_height += pos_y;
	gdk_gc_set_line_attributes(Waat_gc_color[2],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	from_y = height - mrg_height;
	for (loop_cnt = 0; loop_cnt < time_num; loop_cnt++) {
		from_x = mrg_width + scale_x * loop_cnt;
		to_x = mrg_width + scale_x * (loop_cnt + 1);
		to_y = (mrg_height + pos_y) +
				(max_access - time_access[loop_cnt]) * scale_y;
		gdk_draw_rectangle(Waat_pixmap,
				Waat_gc_color[2],
				FALSE,
				from_x, to_y,
				(to_x - from_x), (from_y - to_y));

		// ɽ
		sprintf(draw_str, "%d%s",
			enable_time[loop_cnt], _(WAA_STRG_TIME));
		text_width = wmc_gdk_text_width(Waat_font, Waat_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width +
				(scale_x * (loop_cnt * 2 + 1) - text_width) / 2;
		text_y = height - mrg_height - gdk_text_height(Waat_font,
							draw_str, strlen(draw_str)) * 2;
		wmc_gdk_draw_text(Waat_pixmap,
					Waat_font,
					Waat_kfont,
					Waat_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));

		// ɽ
		sprintf(draw_str, "%d", time_access[loop_cnt]);
		text_width = wmc_gdk_text_width(Waat_font, Waat_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width +
				(scale_x * (loop_cnt * 2 + 1) - text_width) / 2;
		text_y = height - mrg_height - gdk_text_height(Waat_font,
							draw_str, strlen(draw_str));
		wmc_gdk_draw_text(Waat_pixmap,
					Waat_font,
					Waat_kfont,
					Waat_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));
	}
}
