/*
 * ȣХϥե
 *	̲ϥɥ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_week.c,v 1.1 2000/08/15 00:34:46 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static GtkWidget	*Waaw_win;				// ̲ϥɥ
static GtkWidget	*Waaw_darea;			// 襨ꥢ
static GdkPixmap	*Waaw_pixmap = NULL;	// 襨ꥢ
static GdkGC		*Waaw_gc_color[] = {	// ɽ
						NULL, NULL, NULL
					};
static GdkFont		*Waaw_font = NULL;		// ե
static GdkFont		*Waaw_kfont = NULL;		// ܸե

static GtkWidget	*waaw_create_week_window(GtkWidget *);
static void			waaw_cb_destroy_window(void);
static gint			waaw_cb_darea_expose(GtkWidget *, GdkEventExpose *);
static gint			waaw_cb_darea_config(GtkWidget *,
										GdkEventConfigure *);
static void			waaw_create_gc(GtkWidget *);
static void			waaw_draw_week(gint, gint, gint, gint);

/*===============
 *   ̾ : waa_cb_view_week()
 *     ǽ : ̲ϥɥκ
 *    : ʤ
 */
void				waa_cb_view_week(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	gint			vis_win;			// ɽΥɥ

	if (Waaw_win != NULL) {
		gtk_widget_destroy(Waaw_win);
	}
	Waaw_win = waaw_create_week_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(Waaw_win);

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win |= WAA_WINNO_WEEK;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waa_draw_week()
 *     ǽ : ̥(ƽ)
 *    : ʤ
 */
void				waa_draw_week(void)
{
	gint			width;				// 襨ꥢ
	gint			height;				// 襨ꥢ⤵

	if (Waaw_pixmap != NULL) {
		width = (gint)waa_get_param(WAA_PRM_KEY_WEEKWIDTH, 0);
		height = (gint)waa_get_param(WAA_PRM_KEY_WEEKHEIGHT, 0);

		if ((width > 0) && (height > 0)) {
			gdk_draw_rectangle(Waaw_pixmap,
								Waaw_gc_color[1],
								TRUE,
								0, 0,
								width, height);

			waaw_draw_week(0, 0, width, height);

			gdk_draw_pixmap(Waaw_darea->window,
				Waaw_darea->style->fg_gc[GTK_WIDGET_STATE(Waaw_darea)],
				Waaw_pixmap,
				0, 0,
				0, 0,
				width, height);
		}
	}
}

/*===============
 *   ̾ : waa_modify_week_color_gc()
 *     ǽ : ѹ
 *    : ʤ
 */
void				waa_modify_week_color_gc(
gint				color_no,			// ֹ
gchar				*prm_key			// ѥ᡼
)
{
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	temp_color = waa_get_param(prm_key, 0);
	gdk_color_alloc(cmap, temp_color);
	gdk_gc_set_foreground(Waaw_gc_color[color_no], temp_color);
}

/*===============
 *   ̾ : waaw_create_week_window()
 *     ǽ : ̲ϥɥ
 *    : ̲ϥɥ
 */
static GtkWidget	*waaw_create_week_window(
GtkWidget			*parent				// (I) ƥå
)
{
	GtkWidget		*week_window;		// ɥ
	GtkWidget		*draw_vbox;			// 襨ꥢܥå
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_WEEK), NULL);
	week_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(week_window), title); 
	gtk_window_set_default_size(GTK_WINDOW(week_window),
					(gint)waa_get_param(WAA_PRM_KEY_WEEKWIDTH, 0),
					(gint)waa_get_param(WAA_PRM_KEY_WEEKHEIGHT, 0));
	gtk_window_set_position(GTK_WINDOW(week_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(week_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(week_window), "destroy",
						GTK_SIGNAL_FUNC(waaw_cb_destroy_window), NULL);
	g_free(title);

	// 襨ꥢ
	draw_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(week_window), draw_vbox);
	Waaw_darea = gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA(Waaw_darea), 100, 100);
	gtk_box_pack_start(GTK_BOX(draw_vbox), Waaw_darea, TRUE, TRUE, 0);

	gtk_signal_connect(GTK_OBJECT(Waaw_darea), "expose_event",
						(GtkSignalFunc)waaw_cb_darea_expose, NULL);
	gtk_signal_connect(GTK_OBJECT(Waaw_darea), "configure_event",
						(GtkSignalFunc)waaw_cb_darea_config, NULL);

	return week_window;
}

/*===============
 *   ̾ : waaw_cb_destroy_window()
 *     ǽ : ɥõХå
 *    : ʤ
 */
static void			waaw_cb_destroy_window(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			gc_size;			// 顼
	gint			vis_win;			// ɽΥɥ

	gdk_font_unref(Waaw_kfont);
	Waaw_kfont = NULL;
	gdk_font_unref(Waaw_font);
	Waaw_font = NULL;

	gc_size = sizeof(Waaw_gc_color) / sizeof(Waaw_gc_color[0]);
	for (loop_cnt = 0; loop_cnt < gc_size; loop_cnt++) {
		gdk_gc_destroy(Waaw_gc_color[loop_cnt]);
		Waaw_gc_color[loop_cnt] = NULL;
	}
	gdk_pixmap_unref(Waaw_pixmap);
	Waaw_pixmap = NULL;
	gtk_widget_destroy(Waaw_win);
	Waaw_win = NULL;

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win &= ~WAA_WINNO_WEEK;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waaw_cb_darea_expose()
 *     ǽ : 襨ꥢ襳Хå
 *    : FALSE= ｪλ
 */
static gint			waaw_cb_darea_expose(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventExpose		*event				// (I) ٥Ⱦ
)
{
	gdk_draw_pixmap(widget->window,
					widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
					Waaw_pixmap,
					event->area.x, event->area.y,
					event->area.x, event->area.y,
					event->area.width, event->area.height);

	return FALSE;
}

/*===============
 *   ̾ : waaw_cb_darea_config()
 *     ǽ : 襨ꥢꥢ饤Хå
 *    : TRUE= ｪλ
 */
static gint			waaw_cb_darea_config(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventConfigure	*event				// (I) ٥Ⱦ
)
{
	gint			win_size;			// 襨ꥢ⤵

	if (Waaw_pixmap) {
		gdk_pixmap_unref(Waaw_pixmap);
	}
	waaw_create_gc(widget);

	win_size = widget->allocation.width;
	waa_put_param(WAA_PRM_KEY_WEEKWIDTH, (void *)win_size);
	win_size = widget->allocation.height;
	waa_put_param(WAA_PRM_KEY_WEEKHEIGHT, (void *)win_size);

	Waaw_pixmap = gdk_pixmap_new(widget->window,
								widget->allocation.width,
								widget->allocation.height,
								-1);
	gdk_draw_rectangle(Waaw_pixmap,
						Waaw_gc_color[1],
						TRUE,
						0, 0,
						widget->allocation.width,
						widget->allocation.height);
	waa_draw_week();

	return TRUE;
}

/*===============
 *   ̾ : waaw_create_gc()
 *     ǽ : եåƥȤκ
 *    : ʤ
 */
static void			waaw_create_gc(
GtkWidget			*widget				// (I) 襨ꥢ
)
{
	gchar			*prm_key[] = {		// ѥ᡼
						WAA_PRM_KEY_GRAPHFORE,
						WAA_PRM_KEY_GRAPHBACK,
						WAA_PRM_KEY_GRAPHWEEK,
					};
	gint			loop_cnt;			// 롼ץ
	gchar			*font_name;			// ե̾
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	for (loop_cnt = 0; loop_cnt < 3; loop_cnt++) {
		if (!Waaw_gc_color[loop_cnt]) {
			Waaw_gc_color[loop_cnt] = gdk_gc_new(widget->window);
			temp_color = waa_get_param(prm_key[loop_cnt], 0);
			gdk_color_alloc(cmap, temp_color);
			gdk_gc_set_foreground(Waaw_gc_color[loop_cnt], temp_color);
		}
		gdk_gc_set_line_attributes(Waaw_gc_color[loop_cnt],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	}

	if (!Waaw_font) {
		font_name = waa_get_param(WAA_PRM_KEY_FONTNAME, 0);
		Waaw_font = gdk_fontset_load(font_name);
	}
	if (!Waaw_kfont) {
		font_name = waa_get_param(WAA_PRM_KEY_KANJIFONT, 0);
		Waaw_kfont = gdk_fontset_load(font_name);
	}
}

/*===============
 *   ̾ : waaw_draw_week()
 *     ǽ : ̥
 *    : ʤ
 */
static void			waaw_draw_week(
gint				pos_x,				// (I) 賫ϰ
gint				pos_y,				// (I) 賫ϰ
gint				width,				// (I) 
gint				height				// (I) ⤵
)
{
	gint			mrg_width;			// ޡ
	gint			mrg_height;			// ޡ⤵
	gint			text_x;				// ɽ(ƥ)
	gint			text_y;				// ɽ(ƥ)
	gint			text_width;			// ɽƥĹ
	gint			from_x = 0;			// ɽ
	gint			from_y = 0;			// ɽ
	gint			to_x;				// ɽ
	gint			to_y;				// ɽ
	gint			loop_cnt;			// 롼ץ
	gdouble			scale_x;			// غɸ
	gdouble			scale_y;			// ٺɸ
	gchar			draw_str[10];		// ʸ
	gint			access_num;			// 
	gint			max_access;			// 祢
	gint			week_num;			// Τä
	gint			enable_week[54];	// ͭʽ
	gint			week_access[54];	// Υ

	mrg_width = 15;
	mrg_height = 15;
	max_access = 0;
	week_num = 0;
	memset(enable_week, 0, sizeof(enable_week));
	for (loop_cnt = 0; loop_cnt < 54; loop_cnt++) {
		access_num = waa_get_access_num(WAA_WINNO_WEEK, loop_cnt);
		if (max_access < access_num) {
			max_access = access_num;
		}
		if (access_num > 0) {
			enable_week[week_num] = loop_cnt;
			week_access[week_num] = access_num;
			week_num++;
		}
	}

	scale_x = (gdouble)(width - (mrg_width * 2)) / week_num;
	scale_y = (gdouble)(height - (mrg_height * 2)) / max_access;
	mrg_width += pos_x;
	mrg_height += pos_y;
	gdk_gc_set_line_attributes(Waaw_gc_color[2],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	from_y = height - mrg_height;
	for (loop_cnt = 0; loop_cnt < week_num; loop_cnt++) {
		from_x = mrg_width + scale_x * loop_cnt;
		to_x = mrg_width + scale_x * (loop_cnt + 1);
		to_y = (mrg_height + pos_y) +
				(max_access - week_access[loop_cnt]) * scale_y;
		gdk_draw_rectangle(Waaw_pixmap,
				Waaw_gc_color[2],
				FALSE,
				from_x, to_y,
				(to_x - from_x), (from_y - to_y));

		// ɽ
		sprintf(draw_str, "%d%s",
			enable_week[loop_cnt] + 1, _(WAA_STRG_WEEK));
		text_width = wmc_gdk_text_width(Waaw_font, Waaw_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width +
				(scale_x * (loop_cnt * 2 + 1) - text_width) / 2;
		text_y = height - mrg_height - gdk_text_height(Waaw_font,
							draw_str, strlen(draw_str)) * 2;
		wmc_gdk_draw_text(Waaw_pixmap,
					Waaw_font,
					Waaw_kfont,
					Waaw_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));

		// ɽ
		sprintf(draw_str, "%d", week_access[loop_cnt]);
		text_width = wmc_gdk_text_width(Waaw_font, Waaw_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width +
				(scale_x * (loop_cnt * 2 + 1) - text_width) / 2;
		text_y = height - mrg_height - gdk_text_height(Waaw_font,
							draw_str, strlen(draw_str));
		wmc_gdk_draw_text(Waaw_pixmap,
					Waaw_font,
					Waaw_kfont,
					Waaw_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));
	}
}
